SystemOrganization addCategory: #OrionTest!

TestCase subclass: #ASTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionTest'!

ASTest subclass: #ASActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionTest'!

!ASActionTest methodsFor: 'ok' stamp: 'janniklaval 11/20/2012 22:11'!
testASAddClass
	
	|mod sys act|
	sys := self model system. 
	mod := (ASModel withParent: self model) name: #antaresModel.
	
	act := ASActionAddClass new
					antaresModel: mod;
					package: (mod entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTest'.
	
	self assert: (mod entityNamed:#'ClassTest') isNil.
	self assert: mod changes size = 1.

	act run.
	self assert: (mod contains: (mod entityNamed:#'ClassTest')).
	self deny: (sys sourceModel contains: (mod entityNamed:#'ClassTest')).
	
	self assert:(mod  includes: (mod entityNamed:#'ClassTest')).
	self deny:(sys sourceModel includes: (mod entityNamed:#'ClassTest')).
	
	self assert:(mod entityNamed:#'ClassTest') parentPackage = (mod entityNamed:#'Orion-TestModel-Constellation2').
	self assert:((mod entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (mod entityNamed:#'ClassTest')).

	self deny:(((sys sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntitiesAS: sys sourceModel) includes: (mod entityNamed:#'ClassTest')).
	
	
	self deny:(((sys sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities) includes: (mod entityNamed:#'ClassTest')).
	
	self assert: (mod contains: (mod entityNamed:#'Orion-TestModel-Constellation2')).
	self deny: (sys sourceModel contains: (mod entityNamed:#'Orion-TestModel-Constellation2')).
	
	self assert: (mod size = (sys sourceModel size + 1)).
! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:11'!
testAttributeGet

	|antaresModel asAction |
	
	antaresModel := (ASModel withParent: self model) name: #antaresModel.
	
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class5') extendedMethods isEmpty).

	asAction := ASActionExtendMethod new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	asAction run.

	self assert: ((antaresModel entityNamed:#'Smalltalk::Class5') extendedMethods notEmpty).! !

!ASActionTest methodsFor: 'testing OrionModel' stamp: 'janniklaval 11/6/2012 12:04'!
testCreateEntityFrom
	
	|antaresModel asS oldPackage newPackage|
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	oldPackage := antaresModel entityNamed:#'Orion-TestModel-Constellation2'.
	
	self assert: (antaresModel entityNamed:#'Orion-TestModel-Constellation2') = oldPackage.
	self assert: oldPackage mooseModel = self model.
	
	newPackage := antaresModel createEntityFrom: oldPackage.
	
	self assert: oldPackage mooseModel = self model.
	self assert: newPackage mooseModel = antaresModel.
	self assert: (antaresModel entityNamed:#'Orion-TestModel-Constellation2') = newPackage.
	self assert: (asS sourceModel entityNamed:#'Orion-TestModel-Constellation2') = oldPackage.
	
	self assert: (antaresModel contains: newPackage).
	self deny: (antaresModel contains: oldPackage).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:11'!
testLookUp
	
	|antaresModel asSys antaresAction antaresModel2 antaresAction2 |
	
	asSys := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	antaresAction := ASActionAddInheritance new
					antaresModel: antaresModel;
					parent: (antaresModel entityNamed:#'Smalltalk::Class1');
					child: (antaresModel entityNamed:#'Smalltalk::Class2').
	antaresAction run.

	antaresModel2 := (ASModel withParent: antaresModel) name: #AsM2.
	
	antaresAction2 := ASActionAddInheritance new
					antaresModel: antaresModel2;
					parent: (antaresModel2 entityNamed:#'Smalltalk::Class1');
					child: (antaresModel2 entityNamed:#'Smalltalk::Class2').
	antaresAction2 run.
	
	self assert: (((antaresModel2 entityNamed: #'Smalltalk::Class1.accessOrion1Class2()') parentType) = (antaresModel2 entityNamed:#'Smalltalk::Class1')).
	self assert: (antaresModel2 allInheritanceDefinitions collect:[:entity | entity superclass = (antaresModel2 entityNamed:#'Smalltalk::Class1') and:[entity subclass =(antaresModel2 entityNamed:#'Smalltalk::Class2') ] ]) notNil.
	! !

!ASActionTest methodsFor: 'testing OrionModel' stamp: 'janniklaval 11/6/2012 14:00'!
testModelCreation
	
	|antaresModel asS|
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	self assert: asS antaresModels size = 2.
	self assert: (asS sourceModel childrenModel includes: antaresModel).
	self assert: antaresModel parentModel = asS sourceModel.
	self assert: antaresModel system = asS.
	self assert: antaresModel sourceLanguage = asS sourceModel sourceLanguage.
	self assert: antaresModel entityStorage size = asS sourceModel entityStorage size.
	self assert: antaresModel entityStorage size ~= 0.
	! !

!ASActionTest methodsFor: 'testing long' stamp: 'janniklaval 1/16/2013 10:26'!
testMultipleActions
	
	| antaresModel act|
	antaresModel := self modelNetwork.

	
	act := ASActionMoveClass new
						entity: (antaresModel entityNamed:#'Smalltalk::HTTPSocket');
						newContainer: (antaresModel entityNamed:#'Network-Url');
						runOnNewVersionFrom: antaresModel.
		

	ASActionMoveClass new
						entity: (antaresModel entityNamed:#'Smalltalk::HTTPSocket');
						newContainer: (antaresModel entityNamed:#'Network-Kernel');
						runOnNewVersionFrom: act antaresModel.
						
						
		self expectedFailures.	
! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 14:32'!
testOPAddInheritance
	
	|antaresModel asS asAction inheritance|
	asS := self model system. 
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddInheritance new
					antaresModel: antaresModel;
					parent: (antaresModel entityNamed:#'Smalltalk::Class1');
					child: (antaresModel entityNamed:#'Smalltalk::Class2').
	asAction run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class1')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class1')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class1')).
	self assert:(asS sourceModel includes: (asS sourceModel entityNamed:#'Smalltalk::Class1')).
	self deny: ((antaresModel entityNamed:#'Smalltalk::Class1') hash =
		(asS sourceModel entityNamed:#'Smalltalk::Class1') hash).
	
	
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1') subInheritances size = 1).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class2') superInheritances size = 2).
	
	inheritance := (antaresModel entityNamed:#'Smalltalk::Class1') subInheritances at:1.
	
	self assert: (antaresModel contains: inheritance).
	self deny: (asS sourceModel contains: inheritance).
	
	self assert:(antaresModel  includes: inheritance).
	self deny:(asS sourceModel includes: inheritance).
	
	self assert: (inheritance subclass = (antaresModel entityNamed:#'Smalltalk::Class2')).
	self assert: (inheritance superclass = (antaresModel entityNamed:#'Smalltalk::Class1')).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 15:56'!
testOPAddInvocation
	
	|antaresModel asS asAction invoc|
	asS := self model system. 
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddInvocation new
					antaresModel: antaresModel;
					from: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()');
					to: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()').
					
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingInvocations size = 1).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()') incomingInvocations size = 0).
	asAction run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self assert:(asS sourceModel includes: (asS sourceModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingInvocations size = 2).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()') incomingInvocations size = 1).
	
	invoc := (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()') incomingInvocations at:1.
	
	self assert: (antaresModel contains: invoc).
	self deny: (asS sourceModel contains: invoc).
	
	self assert:(antaresModel  includes: invoc).
	self deny:(asS sourceModel includes: invoc).
	
	self assert: (invoc candidates includes: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()')).
	self assert: (invoc sender = (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:15'!
testOPAddMethod
	
	|antaresModel asS asAction|
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					signature: 'methodTest()';
					stringName: 'methodTest';
					containerClass:(antaresModel entityNamed:#'Smalltalk::Class5').
	asAction run.

	self assert: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()') notNil.
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny:((asS sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny:(asS sourceModel includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny:((asS sourceModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.methodTest()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.methodTest()') parentType = (antaresModel entityNamed:#'Smalltalk::Class5').

	self assert: (antaresModel size = (asS sourceModel size + 1)).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:15'!
testOPAddNamespace
	
	|antaresModel asS asAction|
	asS := self model system. 
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddNamespace new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'NamespaceTest'.
	
	self assert: (antaresModel entityNamed:#'NamespaceTest') isNil.
	asAction run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'NamespaceTest')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'NamespaceTest')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'NamespaceTest')).
	self deny:(asS sourceModel includes: (antaresModel entityNamed:#'NamespaceTest')).
	
	self assert:(antaresModel entityNamed:#'NamespaceTest') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'NamespaceTest')).
	self deny:((asS sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'NamespaceTest')).
	
	self assert: (antaresModel size = (asS sourceModel size + 1)).
	! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:15'!
testOPAddPackage
	
	|antaresModel asS asAction|
	asS := self model system. 
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddPackage new
					antaresModel: antaresModel;
					stringName: 'PackageTest'.
	asAction run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'PackageTest')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'PackageTest')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'PackageTest')).
	self deny:(asS sourceModel includes: (antaresModel entityNamed:#'PackageTest')).
	
	self assert:(antaresModel entityNamed:#'PackageTest') parentPackage = nil.
	self assert:(antaresModel entityNamed:#'PackageTest') childNamedEntities isEmpty.	

	self assert: (antaresModel size = (asS sourceModel size + 1)).
	! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:15'!
testOPAddReference
	
	|antaresModel asS asAction ref|
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddReference new
					antaresModel: antaresModel;
					from: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()');
					to: (antaresModel entityNamed:#'Smalltalk::Class5').
					
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingReferences size = 1).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class5') incomingReferences size = 0).
	asAction run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self assert:(asS sourceModel includes: (asS sourceModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingReferences size = 2).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class5') incomingReferences size = 1).
	
	ref := (antaresModel entityNamed:#'Smalltalk::Class5') incomingReferences at:1.
	
	self assert: (antaresModel contains: ref).
	self deny: (asS sourceModel contains: ref).
	
	self assert:(antaresModel  includes: ref).
	self deny:(asS sourceModel includes: ref).
	
	self assert: (ref target = (antaresModel entityNamed:#'Smalltalk::Class5')).
	self assert: (ref source = (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:37'!
testOPExtendMethod
	
	|antaresModel asS asAction |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	self deny:((asS sourceModel entityNamed:#'Smalltalk::Class5') extendedInPackages includes: ((antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage)).
	
	asAction := ASActionExtendMethod new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	asAction run.

	self assert: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') = (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()').
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self deny:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self deny:((asS sourceModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentType = (antaresModel entityNamed:#'Smalltalk::Class5').

	self deny:(asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	
	self deny:((asS sourceModel entityNamed:#'Smalltalk::Class5') extendedInPackages includes: ((antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage)).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') extendedInPackages includes: ((antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage)).
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5') extendedInPackages size = 1.! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:20'!
testOPMoveClassInNamespace
	
	|antaresModel asS asAction asAction2 |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.

	asAction2 := ASActionAddNamespace new
					antaresModel: antaresModel;
					stringName: 'NamespaceTest'.
	asAction2 run.
	
	asAction := ASActionMoveClass new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5');
					newContainer:(antaresModel entityNamed:#'NamespaceTest').
	asAction run.

	self assert: (antaresModel entityNamed:#'NamespaceTest::Class5') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'NamespaceTest::Class5')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk::Class5') = (antaresModel entityNamed:#'NamespaceTest::Class5').
	
	self assert:((antaresModel entityNamed:#'NamespaceTest') types includes: (antaresModel entityNamed:#'NamespaceTest::Class5')).
	self deny:((antaresModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'NamespaceTest::Class5')).
	
	self deny:((asS sourceModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'Smalltalk::Class5')).
	self deny:((antaresModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'NamespaceTest::Class5')).
	self assert:((asS sourceModel entityNamed:#'Smalltalk') types includes: (asS sourceModel entityNamed:#'Smalltalk::Class5')).
	
	self assert:((antaresModel entityNamed:#'NamespaceTest::Class5') methods includes: (antaresModel entityNamed:#'NamespaceTest::Class5.accessOrion2Class3()')).
	
	
	self assert:(antaresModel entityNamed:#'NamespaceTest::Class5') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:(antaresModel entityNamed:#'NamespaceTest::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:19'!
testOPMoveClassInPackage
	
	|antaresModel asS asAction |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.

	asAction := ASActionMoveClass new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	asAction run.

	self assert: (antaresModel entityNamed:#'Smalltalk::Class5') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class5')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk::Class5') = (antaresModel entityNamed:#'Smalltalk::Class5').
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5')).
	self deny:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5')).
	
	self assert:((asS sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (asS sourceModel entityNamed:#'Smalltalk::Class5')).
	self deny:((asS sourceModel entityNamed:#'Orion-TestModel-Constellation1') childNamedEntities includes: (asS sourceModel entityNamed:#'Smalltalk::Class5')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	self deny:(asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (asS sourceModel entityNamed:#'Orion-TestModel-Constellation1').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentType = (antaresModel entityNamed:#'Smalltalk::Class5').! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 17:05'!
testOPMoveMethod
	
	|antaresModel asS asAction |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.

	asAction := ASActionMoveMethod new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()');
					newContainer:(antaresModel entityNamed:#'Smalltalk::Class2').
	asAction run.

	self assert: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()') notNil.
	self assert: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') isNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') = (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()').
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()')).
	self deny:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class2') methods includes: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()')).
	self deny:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()')).
	self assert:(antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	self deny:(asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:(asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (asS sourceModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class2.accessOrion2Class3()') parentType = (antaresModel entityNamed:#'Smalltalk::Class2').! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:14'!
testOPMoveNamespaceInNamespace
	
	|antaresModel asS asAction orionA |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.

	orionA := ASActionAddNamespace new
					antaresModel: antaresModel;
					stringName: 'NamespaceTest'.
	orionA run.
	
	asAction := ASActionMoveNamespace new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk');
					newContainer:(antaresModel entityNamed:#'NamespaceTest').
	asAction run.

	self assert: (antaresModel entityNamed:#'NamespaceTest::Smalltalk') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'NamespaceTest::Smalltalk')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk') = (antaresModel entityNamed:#'NamespaceTest::Smalltalk').
	
	self assert:((antaresModel entityNamed:#'NamespaceTest::Smalltalk') types includes: (antaresModel entityNamed:#'NamespaceTest::Smalltalk::Class5')).
	
	self assert:((asS sourceModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'NamespaceTest::Smalltalk::Class5')).
	
	self assert:((antaresModel entityNamed:#'NamespaceTest') childScopes includes: (antaresModel entityNamed:#'NamespaceTest::Smalltalk')).
	self assert:((antaresModel entityNamed:#'NamespaceTest::Smalltalk') parentScope = (antaresModel entityNamed:#'NamespaceTest')).
	
	self assert:(antaresModel entityNamed:#'NamespaceTest::Smalltalk::Class5') container = (antaresModel entityNamed:#'NamespaceTest::Smalltalk').! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:08'!
testOPMoveNamespaceInPackage
	
	|antaresModel asS asAction |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #antaresModel.
	
	asAction := ASActionMoveNamespace new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	asAction run.

	self assert: (antaresModel entityNamed:#'Smalltalk') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk') = (antaresModel entityNamed:#'Smalltalk').
	
	self assert:((antaresModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'Smalltalk::Class5')).
	
	self assert:((asS sourceModel entityNamed:#'Smalltalk') types includes: (antaresModel entityNamed:#'Smalltalk::Class5')).
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') childScopes includes: (antaresModel entityNamed:#'Smalltalk')).
	self assert:((antaresModel entityNamed:#'Smalltalk') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1')).

	self assert:(antaresModel entityNamed:#'Smalltalk::Class5') container = (antaresModel entityNamed:#'Smalltalk::Class5') container.
	self deny:(antaresModel entityNamed:#'Smalltalk::Class5') container = (asS sourceModel entityNamed:#'Smalltalk::Class5') container.! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:13'!
testOPMovePackage
	
	|antaresModel asS asAction |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionMovePackage new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Orion-TestModel-Constellation1');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	asAction run.

	self assert: (antaresModel entityNamed:#'Orion-TestModel-Constellation1') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Orion-TestModel-Constellation1')).
	
	self deny: (asS sourceModel entityNamed:#'Orion-TestModel-Constellation1') = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Orion-TestModel-Constellation1')).
	
	self deny:((asS sourceModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Orion-TestModel-Constellation1')).
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2')).! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/18/2013 17:09'!
testOPRemoveClass
	
	|antaresModel asAction asM2 asAction2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTest'.
	asAction run.
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed: #'ClassTest').
	asAction2 run.

	self assert: (antaresModel contains: (antaresModel entityNamed: #'ClassTest')).
	self deny: (asM2 contains: (antaresModel entityNamed: #'ClassTest')).
	
	self assert:((antaresModel entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #'ClassTest')).
	
	self deny:((asM2 entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #'ClassTest')).
	
	
	self assert: (antaresModel size = (asM2 size + 1)).! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:02'!
testOPRemoveClassWithInheritanceFrom
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'SuperClassTestFrom'.
	asAction run.

	asAction := ASActionAddInheritance new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo');
					from:  (antaresModel entityNamed: #'ClassTestFrom').
	asAction run.

	asAction := ASActionAddInheritance new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestFrom');
					from:  (antaresModel entityNamed: #'SuperClassTestFrom').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'ClassTestFrom').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestFrom') notNil.
	self assert: (asM2 entityNamed:#'ClassTestFrom') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'ClassTestFrom')).
	"self deny:(asM2 includes: (antaresModel entityNamed:#'ClassTestFrom'))."
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestFrom')).
	"self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestFrom'))."
	
	self assert: (antaresModel entityNamed:#'ClassTestTo') superInheritances first superclass equals: (antaresModel entityNamed:#'ClassTestFrom').
	self assert: (asM2 entityNamed:#'ClassTestTo') superInheritances first superclass equals: (asM2 entityNamed:#'SuperClassTestFrom').
	
	self assert: (antaresModel size) equals: (asM2 size + 2).         "ClassTestFrom , Inheritance"! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:03'!
testOPRemoveClassWithInheritanceTo
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddInheritance new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo');
					from:  (antaresModel entityNamed: #'ClassTestFrom').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'ClassTestTo').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestTo') notNil.
	self assert: (asM2 entityNamed:#'ClassTestTo') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:(asM2 includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert: (antaresModel entityNamed:#'ClassTestFrom') subInheritances size equals: 1.
	self assert: (asM2 entityNamed:#'ClassTestFrom') subInheritances size equals: 0.

	self assert: (antaresModel size) equals: (asM2 size + 2).      "ClassTestTo , Inheritance"! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:07'!
testOPRemoveClassWithInvocationFrom
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					stringName: 'aMethodFrom' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestFrom').
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					stringName: 'aMethodTo' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestTo').
	asAction run.

	asAction := ASActionAddInvocation new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo.aMethodTo()');
					from:  (antaresModel entityNamed: #'ClassTestFrom.aMethodFrom()').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed: #'ClassTestFrom').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestFrom') notNil.
	self assert: (asM2 entityNamed:#'ClassTestFrom') isNil.
	
	self assert: (antaresModel entityNamed:#'ClassTestFrom.aMethodFrom()') notNil.
	self assert: (asM2 entityNamed:#'ClassTestFrom.aMethodFrom()') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed: #'ClassTestFrom')).
	"self deny:(asM2 includes: (antaresModel entityNamed: #'ClassTestFrom'))."
	
	self assert:((antaresModel entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #'ClassTestFrom')).
	"self deny:((asM2 entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #'ClassTestFrom'))."
	
	self assert: (antaresModel entityNamed:#'ClassTestTo.aMethodTo()') incomingInvocations size equals: 1.
	self assert: (asM2 entityNamed:#'ClassTestTo.aMethodTo()') incomingInvocations size equals: 0.

	self assert: (antaresModel size) equals: (asM2 size + 3).     "removed: ClassTestFrom , aMethodFrom , Invocation"! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:10'!
testOPRemoveClassWithInvocationTo
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'aMethodFrom' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestFrom') ;
					signature: 'aMethodFrom()'.
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'aMethodTo' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestTo') ;
					signature: 'aMethodTo()'.
	asAction run.

	asAction := ASActionAddInvocation new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo.aMethodTo()');
					from:  (antaresModel entityNamed: #'ClassTestFrom.aMethodFrom()').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'ClassTestTo').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestTo') notNil.
	self assert: (asM2 entityNamed:#'ClassTestTo') isNil.
	
	self assert: (antaresModel entityNamed:#'ClassTestTo.aMethodTo()') notNil.
	self assert: (asM2 entityNamed:#'ClassTestTo.aMethodTo()') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:(asM2 includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert: (antaresModel entityNamed:#'ClassTestFrom.aMethodFrom()') outgoingInvocations size equals: 1.
	self assert: (asM2 entityNamed:#'ClassTestFrom.aMethodFrom()') outgoingInvocations size equals: 0.

	self assert: (antaresModel size) equals: (asM2 size + 3).     "removed: ClassTestTo , aMethodTo , Invocation"! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:05'!
testOPRemoveClassWithReferenceFrom
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					stringName: 'aMethodFrom' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestFrom').
	asAction run.

	asAction := ASActionAddReference new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo');
					from:  (antaresModel entityNamed: #'ClassTestFrom.aMethodFrom()').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'ClassTestFrom').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestFrom') notNil.
	self assert: (asM2 entityNamed:#'ClassTestFrom') isNil.
	
	self assert: (antaresModel entityNamed:#'ClassTestFrom.aMethodFrom()') notNil.
	self assert: (asM2 entityNamed:#'ClassTestFrom.aMethodFrom()') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'ClassTestFrom')).
	"self deny:(asM2 includes: (antaresModel entityNamed:#'ClassTestFrom'))."
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestFrom')).
	"self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (asM2 entityNamed:#'ClassTestFrom'))."

	self assert: ((antaresModel entityNamed: #'ClassTestFrom.aMethodFrom()') notNil).
	self assert: ((asM2 entityNamed: #'ClassTestFrom.aMethodFrom()') isNil).

	self assert: (antaresModel entityNamed:#'ClassTestTo') incomingReferences size equals: 1.
	self assert: (asM2 entityNamed:#'ClassTestTo') incomingReferences size equals: 0.

	self assert: (antaresModel size) equals: (asM2 size + 3).   "removed: ClassTestFrom , aMethodFrom , Reference"! !

!ASActionTest methodsFor: 'testing' stamp: 'na 1/19/2013 00:04'!
testOPRemoveClassWithReferenceTo
	
	|antaresModel asAction asM2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestTo'.
	asAction run.

	asAction := ASActionAddClass new
					antaresModel: antaresModel;
					package: (antaresModel entityNamed:#'Orion-TestModel-Constellation2');
					stringName: 'ClassTestFrom'.
	asAction run.

	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					stringName: 'aMethodFrom' ;
					containerClass:  (antaresModel entityNamed: #'ClassTestFrom').
	asAction run.

	asAction := ASActionAddReference new
					antaresModel: antaresModel ;
					to:  (antaresModel entityNamed: #'ClassTestTo');
					from:  (antaresModel entityNamed: #'ClassTestFrom.aMethodFrom()').
	asAction run.

	asM2 := (ASModel withParent: antaresModel) name: #AsM2.

	asAction := ASActionRemoveClass new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'ClassTestTo').
	asAction run.

	self assert: (antaresModel entityNamed:#'ClassTestTo') notNil.
	self assert: (asM2 entityNamed:#'ClassTestTo') isNil.
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:(asM2 includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo')).
	"self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'ClassTestTo'))."
	
	self assert: (antaresModel entityNamed:#'ClassTestFrom.aMethodFrom()') outgoingReferences size equals: 1.
	self assert: (asM2 entityNamed:#'ClassTestFrom.aMethodFrom()') outgoingReferences size equals: 0.

	self assert: (antaresModel size) equals: (asM2 size + 2).    "ClassTestTo , Reference"! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:12'!
testOPRemoveInheritance
	
	|antaresModel  asAction oldInh asM2 asAction2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddInheritance new
					antaresModel: antaresModel;
					parent: (antaresModel entityNamed:#'Smalltalk::Class1');
					child: (antaresModel entityNamed:#'Smalltalk::Class2').
	oldInh := asAction run.
	
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveInheritance new
					antaresModel: asM2;
					entity: oldInh.
	asAction2 run.
	
	self assert: (antaresModel contains: oldInh).
	self deny: (asM2 contains: oldInh).
	
	self assert:(antaresModel  includes: oldInh).
	self deny:(asM2 includes: oldInh).
	
	self deny: (antaresModel entityNamed:#'Smalltalk::Class1') subInheritances isEmpty.
	self assert: (asM2 entityNamed:#'Smalltalk::Class1') subInheritances isEmpty.
	
	self assert: (antaresModel entityNamed:#'Smalltalk::Class2') superInheritances size = 2.
	
	self assert: (asM2 entityNamed:#'Smalltalk::Class2') superInheritances size = 1.! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:12'!
testOPRemoveInvocation
	
	|antaresModel asAction oldInv asM2 asAction2 |
	
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddInvocation new
					antaresModel: antaresModel;
					from: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()');
					to: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()').
	oldInv := asAction run.
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveInvocation new
					antaresModel: asM2;
					entity: oldInv.
	asAction2 run.
	
	
	self assert: (antaresModel contains: oldInv).
	self deny: (asM2 contains: oldInv).
	
	self assert:(antaresModel  includes: oldInv).
	self deny:(asM2 includes: oldInv).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion2Class3()') incomingInvocations includes: oldInv).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingInvocations includes: oldInv).
	
	self deny: ((asM2 entityNamed:#'Smalltalk::Class1.accessOrion2Class3()') incomingInvocations includes: oldInv).
	self deny: ((asM2 entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingInvocations includes: oldInv).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:13'!
testOPRemoveMethod
	
	|antaresModel asAction asM2 asAction2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddMethod new
					antaresModel: antaresModel;
					signature: 'methodTest()';
					stringName: 'methodTest';
					containerClass:(antaresModel entityNamed:#'Smalltalk::Class5').
	asAction run.
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveMethod new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'Smalltalk::Class5.methodTest()').
	asAction2 run.


	self assert: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()') notNil.
	self deny: (asM2 entityNamed:#'Smalltalk::Class5.methodTest()') notNil.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny: (asM2 contains: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny:((asM2 entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	self deny:(asM2 includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self deny:((asM2 entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.methodTest()')).
	
	self assert: (antaresModel size = (asM2 size + 1)).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:13'!
testOPRemoveNamespace
	| antaresModel asAction asM2 asAction2 |
	antaresModel := (ASModel withParent: self model) name: #AsM.
	asAction := ASActionAddNamespace new
		antaresModel: antaresModel;
		package: (antaresModel entityNamed: #'Orion-TestModel-Constellation2');
		stringName: 'NamespaceTest'.
	asAction run.
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveNamespace new
		antaresModel: asM2;
		entity: (asM2 entityNamed: #NamespaceTest).
	asAction2 run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed: #NamespaceTest)).
	self deny: (asM2 contains: (antaresModel entityNamed: #NamespaceTest)).
	self assert: (antaresModel includes: (antaresModel entityNamed: #NamespaceTest)).
	self deny: (asM2 includes: (antaresModel entityNamed: #NamespaceTest)).
	self assert: ((antaresModel entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #NamespaceTest)).
	self deny: ((asM2 entityNamed: #'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed: #NamespaceTest)).
	self assert: antaresModel size = (asM2 size + 1)! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/6/2012 12:11'!
testOPRemovePackage
	
	|antaresModel asAction asM2 asAction2 |
	
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddPackage new
					antaresModel: antaresModel;
					stringName: 'PackageTest'.
	asAction run.
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionSafeRemovePackage new
					antaresModel: asM2;
					entity: (asM2 entityNamed:#'PackageTest').
	asAction2 run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'PackageTest')).
	self deny: (asM2 contains: (antaresModel entityNamed:#'PackageTest')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'PackageTest')).
	self deny:(asM2 includes: (antaresModel entityNamed:#'PackageTest')).
	
	self assert: (antaresModel size = (asM2 size + 1)).
	! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:13'!
testOPRemoveReference
	
	|antaresModel asAction oldInh asM2 asAction2 |
	
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	asAction := ASActionAddReference new
					antaresModel: antaresModel;
					from: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()');
					to: (antaresModel entityNamed:#'Smalltalk::Class5').
					
	oldInh := asAction run.
	
	
	asM2 := (ASModel withParent: antaresModel) name: #AsM2.
	asAction2 := ASActionRemoveReference new
					antaresModel: asM2;
					entity: oldInh.
	asAction2 run.
	
	self assert: (antaresModel contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self deny: (asM2 contains: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert:(antaresModel  includes: (antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	self assert:(asM2 includes: (asM2 entityNamed:#'Smalltalk::Class1.accessOrion1Class2()')).
	
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingReferences size = 2).
	self assert: ((antaresModel entityNamed:#'Smalltalk::Class5') incomingReferences size = 1).
	
	self assert: ((asM2 entityNamed:#'Smalltalk::Class1.accessOrion1Class2()') outgoingReferences size = 1).
	self assert: ((asM2 entityNamed:#'Smalltalk::Class5') incomingReferences size = 0).
	
	self assert:(antaresModel  includes: oldInh).
	self deny:(asM2 includes: oldInh).! !

!ASActionTest methodsFor: 'testing' stamp: 'janniklaval 11/20/2012 22:13'!
testOPUnextendMethod
	
	|antaresModel asS asAction asAction2 |
	
	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.

	asAction := ASActionExtendMethod new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()');
					newContainer:(antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	asAction run.

	asAction2 := ASActionUnextendMethod new
					antaresModel: antaresModel;
					entity: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()').
	asAction2 run.
	

	self assert: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') notNil.
	self deny: (asS sourceModel contains: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self deny: (asS sourceModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') = (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()').
	
	self deny:((antaresModel entityNamed:#'Orion-TestModel-Constellation1') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self assert:((antaresModel entityNamed:#'Orion-TestModel-Constellation2') childNamedEntities includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self assert:((antaresModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	self deny:((asS sourceModel entityNamed:#'Smalltalk::Class5') methods includes: (antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()')).
	
	self deny:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation1').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentPackage = (antaresModel entityNamed:#'Orion-TestModel-Constellation2').
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5.accessOrion2Class3()') parentType = (antaresModel entityNamed:#'Smalltalk::Class5').
	
	self assert:(antaresModel entityNamed:#'Smalltalk::Class5') extendedInPackages size = 0.! !

!ASActionTest methodsFor: 'ok' stamp: 'na 1/20/2013 11:38'!
testParenActions
	
	| act1 act2 act3 |

	act1 := ASActionAddEntity new stringName: 'parentAct' ; yourself.
	self assert: (act1 childrenActions isEmpty).
	self assert: (act1 isManual).
	
	act2 := ASActionAddEntity new stringName: '1stChildAct' ; parentAction: act1 ; yourself.
	self assert: (act1 isManual).
	self deny: (act2 isManual).
	self assert: (act2 parentAction) equals: act1.
	self assert: (act1 childrenActions size) equals: 1.
	
	act3 := ASActionAddEntity new stringName: '2ndChildAct' ; parentAction: act1 ; yourself.
	self assert: (act1 childrenActions size) equals: 2.
	
	act2 parentAction: nil.
	self assert: (act2 isManual).
	self assert: (act1 childrenActions size) equals: 1.
! !

ASTest subclass: #ASMetaModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionTest'!

ASTest subclass: #ASModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionTest'!

!ASModelTest methodsFor: 'as yet unclassified' stamp: 'janniklaval 11/6/2012 09:57'!
testASModelCreation
	
	|firstMod secMod sys|
	sys := self model system. 
	firstMod := sys sourceModel.
	secMod := (ASModel withParent: self model) name: #antaresModel.
	
	self assert: TMooseEntity users size = 1.
	self assert: ASClass traits size = 1.
	
	self assert: sys antaresModels size = 2.
	self assert: (sys sourceModel childrenModel includes: secMod).
	
	self assert: firstMod parentModel = nil.
	self assert: firstMod system = sys.
	self assert: firstMod sourceLanguage = secMod sourceLanguage.
	self assert: firstMod entityStorage size = secMod entityStorage size.
	self assert: firstMod entityStorage size = 30.
	
	firstMod entities do:[:e |
		self assert: (e isKindOf: MooseEntity).
	].
	
	self assert: secMod parentModel = sys sourceModel.
	self assert: secMod system = sys.
	self assert: secMod sourceLanguage = sys sourceModel sourceLanguage.
	self assert: secMod entityStorage size = sys sourceModel entityStorage size.
	self assert: secMod entityStorage size ~= 0.
	! !

!ASTest methodsFor: 'accessing' stamp: 'janniklaval 11/20/2012 22:13'!
model

	model isNil ifTrue:[
		| importer mod system|
		mod := MooseModel new.
		importer := MooseSqueakClassCategoryImporterTask new.
		importer importingContext mergeClassAndMetaclass. 
		importer candidateClass: CandidateListOperator.
		importer importerClass: SmalltalkImporter.
		importer model: mod; addFromCategories: #( #'Orion-TestModel-Constellation2' #'Orion-TestModel-Constellation1') ; run.
		
		
		model := ASConverter convertFromMooseModel: mod.
		system := ASSystem new.
		system sourceModel: model.
		model system: system.
		
		^model
	]
	ifFalse:[^model]! !

!ASTest methodsFor: 'accessing' stamp: 'janniklaval 11/20/2012 17:01'!
modelNetwork

		| importer mod system as|
		
	mod := MooseModel new.
	mod name: 'Network'.
	importer := MooseSqueakClassPackageImporterTask new.
	importer importingContext mergeClassAndMetaclass.
	importer runCandidateOperator.
	importer model: mod; addFromPackagesNamed: (MooseScripts packageNamesFor: 'Network*') ; runWithProgress .
		
		as := ASConverter convertFromMooseModel: mod.
		system := ASSystem new.
		system sourceModel: as.
		as system: system.
		^as! !
